博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
525. Contiguous Array两位求和为1的对数
阅读量:5116 次
发布时间:2019-06-13

本文共 1547 字,大约阅读时间需要 5 分钟。

[抄题]:

Given a binary array, find the maximum length of a contiguous subarray with equal number of 0 and 1.

Example 1:

Input: [0,1]Output: 2Explanation: [0, 1] is the longest contiguous subarray with equal number of 0 and 1.

 

Example 2:

Input: [0,1,0]Output: 2Explanation: [0, 1] (or [1, 0]) is a longest contiguous subarray with equal number of 0 and 1.

 [暴力解法]:

时间分析:

空间分析:

 [优化后]:

时间分析:

空间分析:

[奇葩输出条件]:

[奇葩corner case]:

[思维问题]:

以为要用dp,求个数

结果求和类的问题还是要用hashmap

[一句话思路]:

0,1不好弄中间值,把0改成-1后再求中间

[输入量]:空: 正常情况:特大:特小:程序里处理到的特殊情况:异常情况(不合法不合理的输入):

[画图]:

[一刷]:

[二刷]:

[三刷]:

[四刷]:

[五刷]:

  [五分钟肉眼debug的结果]:

[总结]:

0,1不好弄中间值,把0改成-1后再求中间值

[复杂度]:Time complexity: O(n) Space complexity: O(n)

[英文数据结构或算法,为什么不用别的数据结构或算法]:

[算法思想:递归/分治/贪心]:

[关键模板化代码]:

[其他解法]:

[Follow Up]:

[LC给出的题目变变变]:

 [代码风格] :

class Solution {    public int findMaxLength(int[] nums) {        //cc        if (nums == null || nums.length == 0) return 0;            //ini: hashmap, 1 to -1, sum        Map
map = new HashMap<>(); map.put(0, -1); int sum = 0, max = 0; for (int i = 0; i < nums.length; i++) { if (nums[i] == 0) nums[i] = -1; } //for loop, check sum for (int i = 0; i < nums.length; i++) { sum += nums[i]; //contain or not if (map.containsKey(sum)) { max = Math.max(max, i - map.get(sum)); }else { map.put(sum, i); } } return max; }}
View Code

 

转载于:https://www.cnblogs.com/immiao0319/p/9046314.html

你可能感兴趣的文章
Linq to sql介绍及增、删、改、查
查看>>
Word两端对齐问题
查看>>
推荐系统之LFM
查看>>
VMware“该虚拟机似乎正在使用中”问题
查看>>
删除Github上项目
查看>>
Memcached入门
查看>>
[转载]用SQL语句添加删除修改字段
查看>>
高并发架构系列:如何从0到1设计一个类Dubbo的RPC框架
查看>>
(转)Unity 导出XML配置文件,动态加载场景
查看>>
SE 2014 年4月21日(二)
查看>>
UIRefreshControl
查看>>
5.5 用户定义的可调用类型
查看>>
Gym - 101194L World Cup 暴力
查看>>
风螺旋线的公式
查看>>
Leetcode 362: Design Hit Counter
查看>>
Intellij IDEA安装与使用,完整详细。
查看>>
<C#>面试
查看>>
Color Table
查看>>
Leetcode-5019 Video Stitching(视频拼接)
查看>>
ASP.NET MVC传递Model到视图的多种方式之通用方式的使用
查看>>